# Remove previous
data modify storage bungeon:data run.drops set value []
fill -64 101 -64 64 101 64 black_concrete
fill -64 -11 -64 64 6 64 air

# Fix possible broken direction calculation
tp @n[type=marker, tag=direction_calculator, distance=20..] 0 0 0
execute if data storage bungeon:data {floor:3} run return run function bungeon:dungeon/new/boss

# Place Dungeon
forceload remove all
$execute positioned $(dungeon_offset) 0 0 run forceload add ~-64 ~-64 ~64 ~64
forceload add -64 -64 64 64
$scoreboard players set #math bungeon.temp $(dungeon_offset)
execute store result storage bungeon:data dungeon_offset int 1 run scoreboard players add #math bungeon.temp 16
$execute positioned $(dungeon_offset) 0 0 run place structure bungeon:dungeon


# Room Initialization
scoreboard players set #room bungeon.id 0
execute as @e[type=marker, tag=room] at @s run function bungeon:dungeon/new/room/init with storage bungeon:data
data modify entity @e[type=marker, tag=room, tag=!root, limit=1, sort=random] data.type set value "end"

# Corridor Corrections
execute as @e[type=marker, tag=corridor] at @s run function bungeon:dungeon/new/corridor with entity @s data
execute as @e[tag=corridor, type=armor_stand] at @s positioned ^ ^ ^1 unless entity @e[type=armor_stand, tag=corridor, distance=...1] positioned ^ ^ ^-1 run function bungeon:dungeon/new/remove_corridor

kill @e[tag=corridor, type=armor_stand]
kill @e[tag=room, type=armor_stand]

# Start Game Loop
execute as @n[type=marker, tag=root] at @s run function bungeon:dungeon/room/clear/init with entity @s data

schedule function bungeon:dungeon/new/offset/redirect 20t