execute unless entity @a run return run return run schedule function bungeon:load/update 1t
execute if score #tutorial bungeon.temp matches 0 if score #reset bungeon.temp matches 0 run tellraw @a {"translate":"bungeon.updated_110", "fallback":"%s%s", "color":"green", "with":[{"text":"Please download the valid Ressource Pack from ", "color":"red"},{"text":"Modrinth", "color":"green", "underlined":true, "clickEvent":{"action":"open_url","value":"https://modrinth.com/datapack/enter-the-bungeon/version/1.1.0"},"hoverEvent":{"action":"show_text","contents":["Open Page"]}}]}

data modify storage bungeon:data difficulty_scaling set value {health:[100,120],damage:[100,130], attack_cooldown:[100,85], attack_speed:[10,11], attack_range:[10,15]}
data modify storage bungeon:data floor_scaling set value {health:[1.0,1.4,1.9,2.4,3.,3.6,4.5,5.],speed:[1.0,1.1,1.15,1.2,1.25,1.3,1.35,1.4,1.45,1.5],jump:[1.0,1.02,1.04,1.06,1.08,1.1,1.12,1.14,1.16,1.18,2.0], damage:[1.0,1.5,2.,2.,3.,4.,5.,6.], waves:["190..200","195..200","198..200","100..350","100..450"]}
data modify storage bungeon:data upgrade set value [{price:28,modifiers:[{type:"pierce",amount:1},{type:"bullet_speed",amount:-20}]}, {price:15,modifiers:[{type:"speed",amount:10},{type:"health",amount:-5}]}, {price:32,modifiers:[{type:"attack_speed",amount:20},{type:"spread",amount:10},{type:"damage",amount:-5}]}, {price:12,modifiers:[{type:"health",amount:15},{type:"damage",amount:-5}]}, {price:40,modifiers:[{type:"damage",amount:20},{type:"spread",amount:-15},{type:"attack_speed",amount:-15}]}, {price:10,modifiers:[{type:"bullet_speed",amount:30},{type:"damage",amount:-5}]}, {price:25,modifiers:[{type:"lifesteal",amount:3}]}, {price:36,modifiers:[{type:"room_heal",amount:15},{type:"lifesteal",amount:-2}]},{price:24,modifiers:[{type:"damage",amount:20},{type:"lifesteal",amount:-3}]},{price:22,modifiers:[{type:"damage",amount:10},{type:"health",amount:5},{type:"speed",amount:-10}]},{price:19,modifiers:[{type:"attack_speed",amount:10},{type:"damage",amount:-2}]},{price:45,modifiers:[{type:"bullet_bounce",amount:20},{type:"bullet_speed",amount:-25}]},{price:45,modifiers:[{type:"fatal_grace",amount:1}]},{price:33,modifiers:[{type:"reroll",amount:20},{type:"upgrade_coins",amount:-3,path:"run.stats."}]},{price:30,modifiers:[{type:"dare_damage",amount:40},{type:"damage",amount:-10}]},{price:50,modifiers:[{type:"thorns",amount:20},{type:"health",amount:30},{type:"speed",amount:-15}]},{price:26,modifiers:[{type:"item_slots",amount:1},{type:"speed",amount:-10},{type:"damage",amount:-5}]},{price:24,modifiers:[{type:"enemy_coins",amount:15,path:"run.stats."},{type:"enemy_health",amount:10,path:"run.stats."}]},{price:42,modifiers:[{type:"thorn_damage",amount:-2},{type:"damage",amount:-15}]},{price:23,modifiers:[{type:"flawless_coins",amount:20},{type:"hit_coins",amount:-1}]},{price:32,modifiers:[{type:"poison_chance",amount:15},{type:"damage",amount:-10},{type:"health",amount:-10}]},{price:36,modifiers:[{type:"first_hit",amount:50},{type:"attack_speed",amount:-10}]},{price:36,modifiers:[{type:"damage_poison",amount:20},{type:"poison_strength",amount:-5,scaled:1b},{type:"damage",amount:-5}]},{price:30,modifiers:[{type:"attack_speed",amount:10},{type:"crit_chance",amount:3},{type:"damage",amount:-5}]},{price:26,modifiers:[{type:"crit_damage",amount:25},{type:"poison_chance",amount:-5}]},{price:21,modifiers:[{type:"hit_coins",amount:3},{type:"enemy_coins",amount:-30}]},{price:38,modifiers:[{type:"heal_coins",amount:20},{type:"heal",amount:-15}]},{price:44,modifiers:[{type:"damage_coins",amount:2,scaled:1b},{type:"hit_coinp",amount:-1}]},{price:40,modifiers:[{type:"lifesteal_crit",amount:10},{type:"lifesteal",amount:-3}]},{price:26,modifiers:[{type:"attack_speed",amount:15},{type:"speed",amount:10},{type:"crit_chance",amount:-5}]},{price:38,modifiers:[{type:"crit_chance",amount:5},{type:"dodge",amount:4},{type:"poison_chance",amount:-10}]},{price:40,modifiers:[{type:"thorns",amount:35},{type:"damage",amount:-10},{type:"dodge",amount:-2}]},{price:34,modifiers:[{type:"damage",amount:35},{type:"health",amount:-50}]}]
data modify storage bungeon:data item_data set value {auto_rifle:{damage:15, decay:15, spread:10, bullet_speed:80, pierce:0, speed:200, crit_chance:0, poison_chance:0, bullet_amount:1}, health_potion:{health:50}, revolver:{damage:60, decay:20, spread:5, bullet_speed:170, pierce:0, speed:1000, crit_chance:0, poison_chance:0, bullet_amount:1}, shotgun:{damage:30, decay:8, spread:100, bullet_speed:100, pierce:0, speed:2000, crit_chance:0, poison_chance:0, bullet_amount:5}, sword:{damage:45, speed:1500, crit_chance:5, poison_chance:0, melee:true}}
data modify storage bungeon:data enemy_data set value {zombie:{"id":"zombie","entity":"minecraft:zombie","health":28,"damage":12,"speed":0.20,"jump":0.38,"coins":3,"health_height":0.3,"health_scale":1,"attributes":"","nbt":"","tags":"","data":""},slime:{"id":"slime","entity":"minecraft:slime","health":18,"damage":10,"speed":0.5,"jump":0.4,"coins":0,"health_height":0.3,"health_scale":1,"nbt":",Size:1","attributes":"","tags":"","data":""},small_slime:{"id":"small_slime","entity":"minecraft:slime","health":5,"damage":5,"speed":0.55,"jump":0.35,"coins":1,"health_scale":0.75,"health_height":0.3,"attributes":"","nbt":"","tags":"","data":",minor:1b"},skeleton:{"id":"skeleton","entity":"minecraft:skeleton","health":15,"damage":8,"speed":0.20,"jump":0.38,"coins":2,"health_height":0.3,"health_scale":1,"nbt":",HandItems:[{id:\"minecraft:bow\"},{}]","attributes":"","tags":"","data":""},ghost:{"id":"ghost","entity":"minecraft:wandering_trader","health":22,"damage":10,"speed":0.6,"jump":0,"coins":2,"health_height":0.15,"health_scale":1,"hitbox":"minecraft:interaction ~ ~ ~ {width:1,height:1.5,Tags:[\"this\",\"hitbox\",\"clear_run\"],Passengers:[{id:\"minecraft:marker\",Tags:[\"data\",\"ghost\",\"clear_run\"]}]}","attributes":"{id:\"minecraft:step_height\",base:1},","nbt":",Offers:{Recipes:[]}","tags":"","data":""},crystal:{"id":"crystal","entity":"minecraft:wandering_trader","health":15,"damage":50,"speed":0.6,"jump":0,"coins":2,"health_height":0.15,"health_scale":1,"hitbox":"minecraft:interaction ~ ~ ~ {width:1,height:1.5,Tags:[\"this\",\"hitbox\",\"clear_run\"],Passengers:[{id:\"minecraft:marker\",Tags:[\"data\",\"crystal\",\"clear_run\"]}]}","attributes":"{id:\"minecraft:step_height\",base:1},","nbt":",Offers:{Recipes:[]}","tags":"","data":""}}
data modify storage bungeon:data dialogue_length set value {'tutorial.intro0': 16, 'tutorial.intro1': 31, 'tutorial.intro2': 7, 'tutorial.intro3': 34, 'tutorial.explain0': 24, 'tutorial.explain1': 25, 'tutorial.explain2': 27, 'tutorial.sword0': 26, 'tutorial.sword1': 27, 'tutorial.upgrade0': 32, 'tutorial.upgrade1': 30, 'tutorial.outro0': 21, 'tutorial.outro1': 4, 'post_golem.0': 18, 'post_golem.1': 20, 'post_golem.2': 25, 'post_golem.3': 27, 'post_golem.first_run': 22, 'post_golem.many_runs': 12}
data modify storage bungeon:data room set value [{}, {enemy_amount:"2..3", location_amount:"", corner:[8,8], locations:[{pos:"^ ^ ^", size:400}]}, {enemy_amount:"2..4", location_amount:"0..1", corner:[9,9], locations:[{pos:"^2 ^ ^2", size:300}, {pos:"^-5 ^2 ^2", size:50}]}, {enemy_amount:"3..5", location_amount:"0..2", corner:[11,11], locations:[{pos:"^-4 ^ ^4", size:300}, {pos:"^4 ^ ^-4", size:300}, {pos:"^6 ^3 ^6.5", size:200}]}, {enemy_amount:"2..4", location_amount:"0..1", corner:[9,9], locations:[{pos:"^2 ^ ^-3", size:200}, {pos:"^-4 ^ ^", size:200}]}]
data modify storage bungeon:data tips set value [{prefix:"    ", lore:['{"translate":"bungeon.gui.tips.0.0", "with":[{"keybind":"key.swapOffhand"}], "color":"white", "italic":false}','{"translate":"bungeon.gui.tips.0.1", "color":"white", "italic":false}']}, {prefix:"   ", lore:['{"translate":"bungeon.gui.tips.1.0", "with":[{"keybind":"key.drop"}], "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.1.1", "color":"white", "italic":false}']}, {prefix:"      ", lore:['{"translate":"bungeon.gui.tips.2.0", "with":[{"keybind":"key.sneak"}], "color":"white", "italic":false}','{"translate":"bungeon.gui.tips.2.1", "color":"white", "italic":false}']}, {prefix:"            ", lore:['{"translate":"bungeon.gui.tips.3.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.3.1", "color":"white", "italic":false}']}, {prefix:"                ", lore:['{"translate":"bungeon.gui.tips.4.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.4.1", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.4.2", "color":"white", "italic":false}']}, {prefix:"           ", lore:['{"translate":"bungeon.gui.tips.5.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.5.1", "color":"white", "italic":false}']}]

# Set data not in older versions
execute unless data storage bungeon:data progression run data modify storage bungeon:data progression set value {golem:0b}

execute if score #update bungeon.temp matches -3 run return run scoreboard players set #update bungeon.temp 110
data modify storage bungeon:data option set value {connected_lives:false, enemy_health_text:true, difficulty:0}
execute as @a run function bungeon:player/get_name {path:"player/init/update_data"}

kill @e[type=!player]
summon marker 0. 0 0. {Tags:["direction_calculator"]}

gamerule doMobSpawning false
gamerule keepInventory true
gamerule doWeatherCycle false
gamerule commandModificationBlockLimit 999999999
defaultgamemode adventure

setworldspawn 0 20 -14
scoreboard players set #playertp bungeon.temp 1
scoreboard players set #mode bungeon.temp 0

place template bungeon:hub -6 7 -22
execute positioned 0.5 21 -12. run function animated_java:death_toggle/summon {args:{}}

scoreboard players set #update bungeon.temp 110
execute unless score #reset bungeon.temp matches 0 run function bungeon:load/reset
execute unless score #tutorial bungeon.temp matches 0 run function bungeon:load/tutorial